<script>

  import { beforeUpdate, onMount } from 'svelte';

  export let setApp   = null;
  export let number   = '';
  export let contacts = [];

  export let contact = null;
  export let index   = 0;

  let contactName   = '';
  let contactNumber = '';

  function saveContact() {

    if(contact) {

      contact.name   = contactName;
      contact.number = contactNumber;

      window.parent.postMessage(JSON.stringify({action: 'save_contact', contact: {name: contactName, number: contactNumber.toString()}}));

      setApp('contacts');

    } else {
      
      window.parent.postMessage(JSON.stringify({action: 'add_contact', contact: {name: contactName, number: contactNumber.toString()}}))
      setApp('contacts');
    
    }

  }

  onMount(() => {

    contactName   = contact ? contact.name   : '';
    contactNumber = contact ? contact.number : ''; 

  });

</script>

<style>

  .app-contact {
    width: calc(100% - 16px);
    height: 100%;
  }

  .app-contact input[type=number]::-webkit-inner-spin-button, 
  .app-contact input[type=number]::-webkit-outer-spin-button { 
    -webkit-appearance: none; 
    margin: 0; 
  }

  .app-contact input, .app-contact button {
    width: 100%;
    background-color: rgba(0, 0, 0, 0.75);
    border: 1px solid rgba(255, 255, 255, 0.2);
    color: #FFF;
  }

  .app-contact input:focus, .app-contact button:focus
  {
    outline: none;
  }


</style>

<div class="app-contact">

  <div class="contact-name">
    <input type="text" placeholder="John Smith" bind:value={contactName}/>
  </div>

  <div class="contact-number">
    <input type="number" placeholder="0123456789" bind:value={contactNumber}/>
  </div>

  <div class="contact-submit">
    <button on:mouseup={e => saveContact()}><li class="fas fa-save"></li></button>
  </div>

</div>